Subject: Re: linux-next: manual merge of the slab tree with the mm-unstable tree

From: Luiz Capitulino <[email-masked]>
Date: Mon, 21 Jul 2025 17:35:42 -0400

On 2025-07-21 15:38, Matthew Wilcox wrote:
> On Mon, Jul 21, 2025 at 02:20:01PM +1000, Stephen Rothwell wrote:
>> Hi all,
>>
>> Today's linux-next merge of the slab tree got a conflict in:
>>
>>    fs/proc/page.c
>>
>> between commit:
>>
>>    a602ee331e31 ("fs: stable_page_flags(): use snapshot_page()")
>>
>> from the mm-unstable tree and commit:
>>
>>    d8178294c53e ("proc: Remove mention of PG_slab")
>>
>> from the slab tree.
>>
>> I fixed it up (I just used the former version) and can carry the fix as
>> necessary. This is now fixed as far as linux-next is concerned, but any
> 
> I think the snapshot_page commit was incorrect in removing this comment.
> It is still valuable information.  I think the comment from d8178294c53e
> should remain in the tree after the resolution.

The comment wasn't just dropped, David suggested a new version for the comment
(which is similar to yours). The new comment is now part of set_ps_flags()
which is where we set this flag in the snapshot_page() implementation:

static void set_ps_flags(struct page_snapshot *ps, const struct folio *folio,
                          const struct page *page)
{
         /*
          * Only the first page of a high-order buddy page has PageBuddy() set.
          * So we have to check manually whether this page is part of a high-
          * order buddy page.
          */
         if (PageBuddy(page))
                 ps->flags |= PAGE_SNAPSHOT_PG_BUDDY;
         else if (page_count(page) == 0 && is_free_buddy_page(page))
                 ps->flags |= PAGE_SNAPSHOT_PG_BUDDY;

         if (folio_test_idle(folio))
                 ps->flags |= PAGE_SNAPSHOT_PG_IDLE;
}